Name: winePatchMacOSXStackUpdate
ChangeLog: Mac OSX stack update
GenDate: 2006/10/01 11:08:49 UTC
ModifiedFiles: include/msvcrt/process.h tools/winegcc/winegcc.c
AddedFiles: 
Index: include/msvcrt/process.h
===================================================================
RCS file: /home/wine/wine/include/msvcrt/process.h,v
retrieving revision 1.13
diff -u -r1.13 process.h
--- include/msvcrt/process.h	3 Nov 2005 13:17:51 -0000	1.13
+++ include/msvcrt/process.h	1 Oct 2006 11:08:41 -0000
@@ -28,10 +28,15 @@
 #define _WAIT_CHILD      0
 #define _WAIT_GRANDCHILD 1
 
+/* Should this instead just include windef for __stdcall? */
 #ifndef __stdcall
 # ifdef __i386__
 #  ifdef __GNUC__
-#   define __stdcall __attribute__((__stdcall__))
+#   ifdef __APPLE__ /* Mac OSX uses 16-byte aligned stack and not a 4-byte one */
+#    define __stdcall __attribute__((__stdcall__)) __attribute__((__force_align_arg_pointer__))
+#   else
+#    define __stdcall __attribute__((__stdcall__))
+#   endif
 #  elif defined(_MSC_VER)
     /* Nothing needs to be done. __stdcall already exists */
 #  else
Index: tools/winegcc/winegcc.c
===================================================================
RCS file: /home/wine/wine/tools/winegcc/winegcc.c,v
retrieving revision 1.55
diff -u -r1.55 winegcc.c
--- tools/winegcc/winegcc.c	17 Jul 2006 13:15:15 -0000	1.55
+++ tools/winegcc/winegcc.c	1 Oct 2006 11:08:43 -0000
@@ -285,11 +285,19 @@
 
     if (gcc_defs)
     {
+#ifdef __APPLE__ /* Mac OSX uses 16-byte aligned stack and not a 4-byte one */
+	strarray_add(comp_args, "-D__stdcall=__attribute__((__stdcall__)) __attribute__((__force_align_arg_pointer__))");
+	strarray_add(comp_args, "-D__cdecl=__attribute__((__cdecl__)) __attribute__((__force_align_arg_pointer__))");
+	strarray_add(comp_args, "-D_stdcall=__attribute__((__stdcall__)) __attribute__((__force_align_arg_pointer__))");
+	strarray_add(comp_args, "-D_cdecl=__attribute__((__cdecl__)) __attribute__((__force_align_arg_pointer__))");
+#else
 	strarray_add(comp_args, "-D__stdcall=__attribute__((__stdcall__))");
 	strarray_add(comp_args, "-D__cdecl=__attribute__((__cdecl__))");
-	strarray_add(comp_args, "-D__fastcall=__attribute__((__fastcall__))");
 	strarray_add(comp_args, "-D_stdcall=__attribute__((__stdcall__))");
 	strarray_add(comp_args, "-D_cdecl=__attribute__((__cdecl__))");
+#endif
+
+	strarray_add(comp_args, "-D__fastcall=__attribute__((__fastcall__))");
 	strarray_add(comp_args, "-D_fastcall=__attribute__((__fastcall__))");
 	strarray_add(comp_args, "-D__declspec(x)=__declspec_##x");
 	strarray_add(comp_args, "-D__declspec_align(x)=__attribute__((aligned(x)))");
